////////////////////////////////////////////////////////////////////////////
//
// Written by George Cross, Borland C++ Developer Support, July 1997
//
// Copyright (c) 1997 Borland International Inc. All Rights Reserved.
//

#include <tchar.h>
#include <ole2.h>
#include <stdio.h>

#include "ekoala1_ifc.h"

extern "C" const GUID CLSID_Koala =
  { 0x00021146, 0, 0, {0xC0,0,0,0,0,0,0,0x46}};
extern "C" const GUID IID_IKoala = 
  { 0x00021144, 0, 0, {0xC0,0,0,0,0,0,0,0x46}};

void HandleError(_TCHAR* pszMsg = 0, DWORD dwMsgID = GetLastError())
{
  if (pszMsg){
    _tprintf(pszMsg);
  }
  else{
    FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
                  NULL, dwMsgID, 0, (LPTSTR)&pszMsg, 0, NULL);
    _tprintf(pszMsg);
    LocalFree(pszMsg);
  }
  _gettchar();
  OleUninitialize();
  return;
}

////////////////////////////////////////////////////////////////////////////

extern "C" void _tmain()
{

  HRESULT hr;
  IKoala* pIK=NULL;
  IUnknown* pIU=NULL;
  IClassFactory* pCF;
  IDispatch* pID;
  unsigned int KoalaValue=0;
  DISPID dispid;
  DISPPARAMS dispparms = {NULL,NULL,0,0};
  VARIANT VarResult;
  LPWSTR temp = L"Value";
  //_TCHAR temp[40] = _TEXT("Value");

  if (FAILED(OleInitialize(NULL))){
    _tprintf(_TEXT("OleInitialize() failed.\n"));
  }
  
  hr=CoGetClassObject(CLSID_Koala,
                      CLSCTX_LOCAL_SERVER, NULL,IID_IClassFactory,
                      &static_cast<void *>(pCF));
  if (FAILED(hr)){ 
    HandleError(0, hr);
    return;
  }
 
  hr=pCF->CreateInstance(NULL, IID_IDispatch,
                      &static_cast<void *>(pID));
  if (FAILED(hr)){ 
    HandleError(0, hr);
    return;
  }

  pID->GetIDsOfNames(IID_NULL,&temp,1,
                     LOCALE_USER_DEFAULT,&dispid);
  if (FAILED(hr)){ 
    HandleError(0, hr);
    return;
  }

  VariantInit(&VarResult);

  pID->Invoke(dispid,IID_NULL,LOCALE_USER_DEFAULT,DISPATCH_PROPERTYGET,
              &dispparms,&VarResult,NULL,NULL);
  if (FAILED(hr)){ 
    HandleError(0, hr);
    VariantClear(&VarResult);
    return;
  }

  VariantClear(&VarResult);
  _tprintf(_TEXT("EKoala.Value is %d.\n"),VarResult.lVal);
  _tprintf(_TEXT("IID_IUnknown obtained on Koala object. Press any key to release interface.\n"));
  _gettchar();

  pCF->Release();

  OleUninitialize();
  return;
}

