#ifndef _KOALA_H_
#define _KOALA_H_

#include "ekoala1_ifc.h"

//KOALA.CPP

//Type for an object-destroyed callback
typedef void (*PFNDESTROYED)(void);

class CKoala : public IKoala
    {
    protected:
        UINT*           m_pValue;
        ULONG           m_cRef;         //Object reference count
        LPUNKNOWN       m_pUnkOuter;    //Controlling unknown

        PFNDESTROYED    m_pfnDestroy;   //To call on closure
        LPTYPEINFO          m_pITINeutral;          
        LPUNKNOWN           m_pIUnkStdDisp;      

    public:
        CKoala(LPUNKNOWN, PFNDESTROYED);
        ~CKoala(void);

        BOOL Init(void);

        //Non-delegating object IUnknown
        STDMETHODIMP         QueryInterface(REFIID, void**);
        STDMETHODIMP_(ULONG) AddRef(void);
        STDMETHODIMP_(ULONG) Release(void);
   
        //IKoala methods
        STDMETHODIMP_(UINT) get_Value(){ return *m_pValue++;}
        void STDMETHODCALLTYPE        put_Value(UINT v){ *m_pValue = v; }
    };

typedef CKoala *PCKoala;

#endif //_KOALA_H_
